"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var az_api_maps_loader_1 = require("../../services/az-api-maps-loader");
var az_api_maps_wrapper_1 = require("../../services/az-api-maps-wrapper");
var AZMapChildComponent_1 = require("../../entities/AZMapChildComponent");
var polyline = require('polyline');
var AZMapPolylineComponent = (function (_super) {
    __extends(AZMapPolylineComponent, _super);
    function AZMapPolylineComponent(_element, _loader, _wrapper) {
        _super.call(this);
        this._element = _element;
        this._loader = _loader;
        this._wrapper = _wrapper;
    }
    AZMapPolylineComponent.prototype.optionsAvailable = function () {
        return [
            'clickable',
            'draggable',
            'editable',
            'geodesic',
            'icons',
            'map',
            'path',
            'strokeColor',
            'strokeOpacity',
            'strokeWeight',
            'visible',
            'zIndex'
        ];
    };
    AZMapPolylineComponent.prototype.ngOnInit = function () {
        var _this = this;
        this._loader.load().then(function () {
            _this._defineMapId();
            _this._createPolyline();
        });
    };
    AZMapPolylineComponent.prototype._createPolyline = function () {
        if (this.polylinePath) {
            this.path = polyline.decode(this.polylinePath).map(function (item) { return Object.assign({ lat: item[0], lng: item[1] }); });
        }
        var flightPath = new google.maps.Polyline(this.getComponentOptions());
        flightPath.setMap(this._wrapper.getNativeMap(this.mapId));
    };
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], AZMapPolylineComponent.prototype, "clickable", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], AZMapPolylineComponent.prototype, "draggable", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], AZMapPolylineComponent.prototype, "editable", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], AZMapPolylineComponent.prototype, "geodesic", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Array)
    ], AZMapPolylineComponent.prototype, "icons", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Object)
    ], AZMapPolylineComponent.prototype, "path", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], AZMapPolylineComponent.prototype, "strokeColor", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], AZMapPolylineComponent.prototype, "strokeOpacity", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], AZMapPolylineComponent.prototype, "strokeWeight", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Boolean)
    ], AZMapPolylineComponent.prototype, "visible", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', Number)
    ], AZMapPolylineComponent.prototype, "zIndex", void 0);
    __decorate([
        core_1.Input(), 
        __metadata('design:type', String)
    ], AZMapPolylineComponent.prototype, "polylinePath", void 0);
    AZMapPolylineComponent = __decorate([
        core_1.Component({
            selector: 'az-map-polyline',
            template: ''
        }), 
        __metadata('design:paramtypes', [core_1.ElementRef, az_api_maps_loader_1.AZApiMapsLoaderService, az_api_maps_wrapper_1.AZApiMapsWrapperService])
    ], AZMapPolylineComponent);
    return AZMapPolylineComponent;
}(AZMapChildComponent_1.AZMapChildComponent));
exports.AZMapPolylineComponent = AZMapPolylineComponent;
//# sourceMappingURL=az-mp-polyline.component.js.map