"use strict";
var az_api_maps_wrapper_1 = require("./az-api-maps-wrapper");
describe('AzApiMapsWrapper service', function () {
    it('should add a map to the page', function (done) {
        var wrapper = new az_api_maps_wrapper_1.AZApiMapsWrapperService();
        var div = document.createElement('div');
        document.body.appendChild(div);
        expect(div.innerHTML).toBeFalsy();
        wrapper.loadMap(div, { center: { lat: 25.25, lng: 36.36 }, zoom: 8 });
        expect(div.innerHTML).toBeTruthy();
        waitForExpectation(function () { return div.getElementsByClassName('gm-style').length > 0; }, 20, done);
    });
    it('should increase returned loadMap index', function () {
        var wrapper = new az_api_maps_wrapper_1.AZApiMapsWrapperService();
        for (var i = 0; i < 3; i++) {
            var div = document.createElement('div');
            document.body.appendChild(div);
            var index = wrapper.loadMap(div, { center: { lat: 25.25, lng: 36.36 }, zoom: 8 });
            expect(index).toEqual(i);
        }
    });
});
function waitForExpectation(expectationFunc, timer, done) {
    if (!expectationFunc()) {
        setTimeout(waitForExpectation.bind(null, expectationFunc, timer, done), timer);
        return;
    }
    expect(expectationFunc()).toBeTruthy();
    done();
}
//# sourceMappingURL=az-api-maps-wrapper.spec.js.map